from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.CMFCore.DirectoryView import createDirectoryView

def install(self):
    out = []
    skinsTool = getToolByName(self, 'portal_skins')
    actionsTool = getToolByName(self, 'portal_actions')

    layer_name = "HoverHelp"
    layer_location = "HoverHelp/skins"

    # add in the directory view pointing to our skin
    if layer_name not in skinsTool.objectIds():
        createDirectoryView(skinsTool, layer_location, layer_name)
        out.append('Added "%s" directory view to portal_skins' % layer_name)

    # add in the layer to all our skins
    skins = skinsTool.getSkinSelections()
    for skin in skins:
        path = skinsTool.getSkinPath(skin)
        path = [ p.strip() for p in path.split(',') ]
        if layer_name not in path:
            path.insert(path.index('custom')+1, layer_name)

            path = ", ".join(path)
            skinsTool.addSkinSelection(skin, path)
            out.append('Added "%s" to "%s" skins' % (layer_name, skin))
        else:
            out.append('Skipping "%s" skin' % skin)
    
    if "hover_help" not in self.objectIds():
        self.manage_addProduct['HoverHelp'].manage_addTool('HoverHelp')
        out.append("Added tool")
    
    found = False
    aid = "hover_help"
    for action in actionsTool.listActions():
        if action.id == aid:
            found = True
            break

# This is what we'd ideally like to do.
#    if not found:
#        actionsTool.addAction(aid,
#            'Help',
#            "string:${object_url}/getHelp",
#            '', #condition
#            'View',
#            'site_actions',
#            1)
#        out.append("Added link")

    return '\n'.join(out)
