import os
from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem
from AccessControl import ClassSecurityInfo

from Globals import DevelopmentMode
from Products.CMFCore.utils import UniqueObject, getToolByName

class Tool(UniqueObject, SimpleItem):
    """ Hover Tool """
    meta_type = "HoverHelp"
    id = "hover_help"

    security = ClassSecurityInfo()

    registry = {
        }

    security.declareProtected("View", "getHelpFor")
    def getHelpFor(self, obj):
        """ Return help from a set of page templates for id """
        # allow overrides here
        page = self.registry.get(obj.portal_type, None)
        
        # get the page template and call it
        if page is None:
            
            # find the page automagically
            page = obj.portal_type.lower().replace(" ", "_")
            page = getattr(self, page, None)

            if page is None:
                page = getattr(self, "main_help")
        
        return page()

    security.declarePublic("isDebug")
    def isDebug(self):
        """ In debug? """
        return DevelopmentMode

InitializeClass(Tool)
